"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.check = exports.ValidationError = void 0;
const types_1 = require("./types");
class ValidationError extends Error {
    constructor(issues) {
        super('Validation failed');
        this.issues = issues;
        this.name = 'ValidationError';
        Object.setPrototypeOf(this, new.target.prototype);
    }
}
exports.ValidationError = ValidationError;
const check = (check, value, path = []) => {
    const result = check.process(value(), Array.isArray(path) ? path : [path]);
    if ((0, types_1.isIssue)(result)) {
        throw new ValidationError(result.issues);
    }
    return result.value;
};
exports.check = check;
//# sourceMappingURL=check.js.map