import { CommonValidationOptions } from './common';
import { StringFormatCheck } from './string-format';
interface StringPadding {
    length: number;
    padWith: string;
}
type StringTransform = (value: string) => string;
interface CoerceOptions {
    limitLength?: number;
    padStart?: StringPadding;
    padEnd?: StringPadding;
    transform?: StringTransform | StringTransform[];
    trim?: 'start' | 'end' | 'both' | 'none';
}
interface ValidationOptions extends CommonValidationOptions<string> {
    format?: StringFormatCheck;
    regex?: RegExp;
    maxLength?: number;
    minLength?: number;
}
export declare const isString: (options?: (CoerceOptions & ValidationOptions) | undefined) => import("./types").ValueProcessor<string>;
export declare const maybeString: (options?: (import("./common").MaybeOptions & CoerceOptions & ValidationOptions) | undefined) => import("./types").ValueProcessor<string | undefined>;
export declare const asString: (options?: (import("./common").WithDefault<string> & import("./common").CommonConvertOptions<string> & CoerceOptions & ValidationOptions) | undefined) => import("./types").ValueProcessor<string>;
export declare const maybeAsString: (options?: (import("./common").MaybeOptions & import("./common").WithDefault<string> & import("./common").CommonConvertOptions<string> & CoerceOptions & ValidationOptions) | undefined) => import("./types").ValueProcessor<string | undefined>;
export {};
